#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>
#include <FL/fl_draw.H>
#include <FL/Fl_Box.H>
#include <stdio.h>
#include <stdlib.h>
//#include <pthread.h>
#include <Windows.h>
#include <GL/gl.h>

#define FLTK_WAIT 1000
#define ACTION_WAIT 1300

class Window
    : public Fl_Gl_Window
{
public:
    Window(int x,int y,int w,int h)
        : Fl_Gl_Window(x,y,w,h)
        , color(0)
    {}

    virtual void draw()
    {
        glColor3b((color>>16)&0xff,(color>>8)&0xff,color&0xff);
        glRectf(-1,-1,1,1);
    }

    int color;
};

static int flag = -1;

static void action()
{
    // set flag
    flag = (float)rand()/RAND_MAX*0xffffff;
    printf("--THREAD-- %x\n",flag);
    // wake up FLTK
    Fl::awake();
}

static void *thrfunc(void *)
{
    for(;;) {
        action();
        // wait a bit (longer than 1 second)
        Sleep(ACTION_WAIT);
    }
    return NULL;
}

static void tmrfunc(void *)
{
    action();
    Fl::repeat_timeout(ACTION_WAIT*0.001,tmrfunc);
}

int main(int argc, char **argv) 
{
#if 0
    pthread_t thr;
    pthread_create(&thr,NULL,thrfunc,NULL);
#else
    Fl::add_timeout(ACTION_WAIT*0.001,tmrfunc);
#endif

    Fl::lock();

    Window *window = new Window(50,50,200,200);
    window->show();

    while(true) {

        // check for color update
        if(flag >= 0) {
            window->color = flag;
            flag = -1;

            // redraw window
            window->redraw();
        }

        // wait 1 second
        Fl::wait(FLTK_WAIT*0.001);
    }

    return 0;
}
